/*
Copyright (c) 2006 Arthur Huillet

TINS'06 entry


Help screen
*/
#include "all_inc.h"

void help_screen()
{ //help screen input code
char end = 0;
while(key[KEY_F1]) rest(10);
while(!end)
	{	
	display_all();
	if(key[KEY_F1] || key[KEY_ESC]) end = 1;
	rest(50);
	if(!help_page_num) help_page_num = 1;
	if(keypressed())
		{
		int keyp = readkey() >> 8;
		if(keyp == KEY_LEFT && help_page_num != 1)
			help_page_num --;
		if(keyp == KEY_RIGHT && help_page_num != 5)
			help_page_num ++;
		}
	}
}

void display_help_screen()
{
rectfill(vscreen[page_num], RESOL_X * 0.08, RESOL_Y * 0.1, RESOL_X * 0.92, RESOL_Y * 0.9, makecol(127, 127, 127));
rect(vscreen[page_num], RESOL_X * 0.08, RESOL_Y * 0.1, RESOL_X * 0.92, RESOL_Y * 0.9, makecol(0, 0, 255));
textprintf_centre_ex(vscreen[page_num], font, RESOL_X * 0.5, RESOL_Y * 0.1 + 8, makecol(255, 0, 0), -1, "HELP");
textprintf_ex(vscreen[page_num], font, RESOL_X * 0.1 + 40, RESOL_Y * 0.1 + 40, makecol(10, 70, 10), -1, "Summary");
textprintf_ex(vscreen[page_num], font, RESOL_X * 0.1 + 140, RESOL_Y * 0.1 + 40, (help_page_num == 1) ? makecol(31, 31, 31) : makecol(95, 95, 95), -1, "1 plot");
textprintf_ex(vscreen[page_num], font, RESOL_X * 0.1 + 233, RESOL_Y * 0.1 + 40, (help_page_num == 2) ? makecol(31, 31, 31) : makecol(95, 95, 95), -1, "2 rules");
textprintf_ex(vscreen[page_num], font, RESOL_X * 0.1 + 335, RESOL_Y * 0.1 + 40, (help_page_num == 3) ? makecol(31, 31, 31) : makecol(95, 95, 95), -1, "3 controls");
textprintf_ex(vscreen[page_num], font, RESOL_X * 0.1 + 457, RESOL_Y * 0.1 + 40, (help_page_num == 4) ? makecol(31, 31, 31) : makecol(95, 95, 95), -1, "4 misc");
textprintf_ex(vscreen[page_num], font, RESOL_X * 0.1 + 550, RESOL_Y * 0.1 + 40, (help_page_num == 5) ? makecol(31, 31, 31) : makecol(95, 95, 95), -1, "5 credits");
rect(vscreen[page_num], RESOL_X * 0.1 + 35, RESOL_Y * 0.1 + 30, RESOL_X * 0.1 + 630, RESOL_Y * 0.1 + 50, makecol(192, 192, 192));
//and now, the content of the page//
switch(help_page_num)
	{
	case 1: draw_message("   Story\n \n This game is called HTK : Humankind Train Keeper.\n You, the player, are assigned to protect the humankind during its trip from year 0 to nowadays.\n Humans need your protection because their train is likely to be attacked." \
		"As you know, life isn't always easy, and you'll have to cope with 2006 years of matters.\n \n Good luck !"); break;
	case 2: draw_message("   Rules\n \n Escort the train from year 0 to year 2006. Remain close to the train and help the humankind survive. Every bomb you haven't defused, every problem you haven't killed, will make the humans lose fatepoints. No fatepoint equals death. Death equals game over.\n \n" \
		"\n \n You can defuse bombs, and use three weapons to kill enemies of the humankind. The ASCII Garbagethrower is the most powerful weapon but also the slowest." \
	"A lot of people love the Eradicator Beam for its ability of immediate cleaning over long ranges."
	"Do not forget your standard gun which will always be available when the two others are reloading (weapon autoswitch). Use it by clicking directly on a monster."); break;
	case 3: draw_message("   Input\n \n Move with the arrow keys.\n Aim and kill monsters with the left button.\n Take the ASCII Garbagethrower with the right button. Once empty, you will automagically switch back to the Eradicator Beam.\nDefuse bombs by keeping space or right shift pressed for a while when standing close to them.\n  There is a delay to defuse bombs, but fortunately you can't fail at it.\n You can change the difficulty level with backspace.\n Use P to pause.\n Leave humankind to its pitiful fate with ESC." \
		""); break;
	#ifndef _AHPRIV
	case 4: draw_message("   Misc\n \n  The train of humankind goes on the rails of time. You are viewing the help screen.\nThe player and train are ASCII-art, along with this:\n"
		"   _  _\n  / \\/ \\\n  \\    /\n   \\  /\n    \\/\n \n (thinking of someone)\n Nox and I have girlfriends both named Marion."); break;
	#endif
	case 5: draw_message("   Credits\n \n HTK : A.Huillet's TINS'06 entry.\n Code by Arthur Huillet.\n \n Graphics and beta-test by Nox\n \n \n Some code was taken from Zlog.\n Bomb is from Supertux.\n \n HTK is under GPL."); break;
	}
	
textprintf_ex(vscreen[page_num], font, RESOL_X * 0.92 - 80, RESOL_Y * 0.9 - 25, makecol(31, 31, 31), -1, "Page: %i/%i", help_page_num, 5);
textprintf_centre_ex(vscreen[page_num], font, RESOL_X * 0.5, RESOL_Y * 0.9 - 12, makecol(63, 63, 63), -1, "'f1' to resume");
}

void draw_message(char * msg) 
{
char * msgoffset = msg;
char msgline[90];

for(int y = 0.1 * RESOL_Y + 100; y < RESOL_Y * 0.9 - 40; y += 10)
        {
        memset(msgline, 0, 90);
        int done = 0;
        unsigned int charcount = 0;
        while(charcount <= 80 && charcount < strlen(msgoffset) /*&& ( msgoffset[charcount] != ' ' || msgoffset[charcount] != '\n')*/)
                {
                charcount ++;
                if((charcount > 70 && msgoffset[charcount] == ' ') || msgoffset[charcount] == '\n')
                        break;
                }
        if(msgoffset[0] == ' ') msgoffset ++;
        
        if(charcount >= strlen(msgoffset))
               done = 1;
        strncpy(msgline, msgoffset, charcount);
        for(unsigned int i = 0; i < strlen(msgline); i++)
                {
                if(msgline[i] == '\n') msgline[i] = ' ';
                if(msgline[i] == '\t') msgline[i] = ' ';
                }
        msgoffset += charcount;
        textout_justify_ex(vscreen[page_num], font, msgline, 0.08 * RESOL_X + 40, 0.92 * RESOL_X - 40, y, 80, makecol(0, 0, 0), -1);
        
        if(done) break;
        }
}








