/*
Copyright (c) 2006 Arthur Huillet

TINS'06 entry


Init functions
*/

#include "all_inc.h"

int init_player()
{
player.refpt.x = 4000;
player.refpt.y = 30000;
player.weap = 1;
for(int i =0; i < PLAYER_SIZE; i++)
	memset(player.draw[i], 0, PLAYER_SIZE);
sprintf(player.draw[0], "   /\\");
sprintf(player.draw[1], "|   |");
sprintf(player.draw[2], "|---|");
sprintf(player.draw[3], "| O |");
sprintf(player.draw[4], " --- ");

crosshair.offset_rp.x = 4*(PLAYER_SIZE-1);
crosshair.offset_rp.y = - 50;
current_year = 0;
render_player();
screen_offset.x = 3800;
screen_offset.y = 29800;
life = 100;
defuse_time = -1;
defuse_bomb = NULL;
beam.time_rng = -1;
difficulty_level = 1;
return 0;
}


int init_railroad()
{
train_pos = NULL;
railroad = NULL;
point move;
move.x = 0; move.y = -48;
rail_pieces = add_railroad_part(rail_pieces, '|', move);
move.x = 48; move.y = -48;
rail_pieces = add_railroad_part(rail_pieces, '/', move);
move.x = 48; move.y = 0;
rail_pieces = add_railroad_part(rail_pieces, '-', move);
move.x = 48; move.y = 48;
rail_pieces = add_railroad_part(rail_pieces, '\\', move);
move.x = 0; move.y = 48;
rail_pieces = add_railroad_part(rail_pieces, 'V', move);

part_sprites.dash = load_bitmap("dash.bmp", NULL);
part_sprites.slash = load_bitmap("slash.bmp", NULL);
part_sprites.antislash = load_bitmap("antislash.bmp", NULL);
part_sprites.pipe = load_bitmap("pipe.bmp", NULL);
move.x = 4000;
move.y = 30000;
railroad = add_railroad_part(railroad, '-', move);
//screen_first_part = railroad;
train_pos = railroad; 
rail_screen_pos.x = 4048;
rail_screen_pos.y = 30000;
generate_railroad();
generate_bombs();
log_msg(3, "Railroad ready");
train = load_bitmap("lomomo.bmp", NULL);
return 0;
}

int generate_railroad()
{
/*if(screen_first_part)
	if(screen_first_part->PREV)
		{
		(screen_first_part->PREV)->NEXT = NULL;
		free_railroad(railroad);
		railroad = screen_first_part;
		}*/
//now to generate ...
railpart * current_part = search_for_part('-');
point partpos = rail_screen_pos;
if(!current_part) log_msg(0, "Rail part missing ?!");
int i = 0;
while(i < 2010)
	{
	if(rand() % 4) // turn
		{
		if(rand() % 2)
			{ //turn left
			if(current_part->PREV) 
				{
				partpos.x += current_part->PREV->pos.x;
				partpos.y += current_part->PREV->pos.y;
				railroad = add_railroad_part(railroad, current_part->PREV->part, partpos);
				partpos.x += current_part->PREV->pos.x;
				partpos.y += current_part->PREV->pos.y;
				current_part = current_part->PREV;
				}
			else if(current_part->NEXT)  //if not possible go right
				{
				partpos.x += current_part->NEXT->pos.x;
				partpos.y += current_part->NEXT->pos.y;
				railroad = add_railroad_part(railroad, current_part->NEXT->part, partpos);
				partpos.x += current_part->NEXT->pos.x;
				partpos.y += current_part->NEXT->pos.y;
				current_part = current_part->NEXT;
				}
			} 
		else { //turn right
			if(current_part->NEXT)
				{
				partpos.x += current_part->NEXT->pos.x;
				partpos.y += current_part->NEXT->pos.y;
				railroad = add_railroad_part(railroad, current_part->NEXT->part, partpos);
				partpos.x += current_part->NEXT->pos.x;
				partpos.y += current_part->NEXT->pos.y;
				current_part = current_part->NEXT;
				}
			else if(current_part->PREV) //if not possible go left
				{
				partpos.x += current_part->PREV->pos.x;
				partpos.y += current_part->PREV->pos.y;
				railroad = add_railroad_part(railroad, current_part->PREV->part, partpos);
				partpos.x += current_part->PREV->pos.x;
				partpos.y += current_part->PREV->pos.y;
				current_part = current_part->PREV;
				}
			}
		}
	else { //go straightforward
		partpos.x += current_part->pos.x;
		partpos.y += current_part->pos.y;
		railroad = add_railroad_part(railroad, current_part->part, partpos);
		partpos.x += current_part->pos.x;
		partpos.y += current_part->pos.y;
		}
	i += 10;
	}
return 0;
}

railpart * add_railroad_part(railpart * first, char part, point pos)
{
railpart * new_obj = (railpart *)calloc(1, sizeof(railpart));
new_obj->part = part;
new_obj->pos = pos;
railpart * last = first;
if(first)
	while(last->NEXT)
		last = last->NEXT;
new_obj->PREV = last;
log_msg(3, "Adding %c to railroad", new_obj->part);
if(last) 
	{
	last->NEXT = new_obj;
	return first;
	}
log_msg(3, "Railroad's empty : returning new_obj directly");
return new_obj;
}

int free_railroad(railpart * target)
{
railpart * cur = target;
while(target)
	{
	cur = target->NEXT;
	free(target);
	target = cur;
	}
return 0;
}

railpart * search_for_part(char part)
{
railpart * cur = rail_pieces;
while(cur)
	{
	if(cur->part == part)
		return cur;
	cur = cur->NEXT;
	}
return NULL;
}

void generate_bombs()
{
railpart * cur = railroad;
int count = 0;
int fbomb = 1;
while(cur)
	{
	if(!(rand() % 4) && count > 5)
		{
		first_bomb = add_bomb(first_bomb, cur->pos.x + (rand() % 50), cur->pos.y + (rand() % 50), bomb_spr, 32);
		if(fbomb == 1) last_bomb = first_bomb;
		fbomb = 0;
		}
	count ++;
	cur = cur->NEXT;
	}
}
